commit 359cc8d9171fee83fc82af07f7b6de81fc42ca95
Author: NOYB <Al_Stu@Frontier.com>
Date:   Wed Mar 30 23:55:07 2016 -0700

    Services / DNS Resolver - Remove Personalizations
    
    Remove "you" personalizations.

diff --git a/src/usr/local/www/services_unbound.php b/src/usr/local/www/services_unbound.php
index 4408d2acc6..b99ec698eb 100644
--- a/src/usr/local/www/services_unbound.php
+++ b/src/usr/local/www/services_unbound.php
@@ -177,7 +177,7 @@ if ($_POST) {
 		}
 
 		if ($pconfig['port'] && !is_port($pconfig['port'])) {
-			$input_errors[] = gettext("You must specify a valid port number.");
+			$input_errors[] = gettext("A valid port number must be specified.");
 		}
 
 		if (is_array($pconfig['active_interface']) && !empty($pconfig['active_interface'])) {
@@ -283,7 +283,7 @@ if ($savemsg) {
 }
 
 if (is_subsystem_dirty('unbound')) {
-	print_apply_box(gettext("The DNS resolver configuration has been changed.") . "<br />" . gettext("You must apply the changes in order for them to take effect."));
+	print_apply_box(gettext("The DNS resolver configuration has been changed.") . "<br />" . gettext("The changes must be applied for them to take effect."));
 }
 
 $tab_array = array();
@@ -360,16 +360,15 @@ $section->addInput(new Form_Checkbox(
 	$pconfig['regdhcp']
 ))->setHelp(sprintf('If this option is set, then machines that specify their hostname when requesting a DHCP lease will be registered'.
 					' in the DNS Resolver, so that their name can be resolved.'.
-					' You should also set the domain in %sSystem: General setup%s to the proper value.','<a href="system.php">','</a>'));
+					' The domain in %sSystem: General setup%s should also be set to the proper value.','<a href="system.php">','</a>'));
 
 $section->addInput(new Form_Checkbox(
 	'regdhcpstatic',
 	'Static DHCP',
 	'Register DHCP static mappings in the DNS Resolver',
 	$pconfig['regdhcpstatic']
-))->setHelp(sprintf('If this option is set, then DHCP static mappings will be registered in the DNS Resolver, so that their name can be '.
-					'resolved. You should also set the domain in %s'.
-					'System: General setup%s to the proper value.','<a href="system.php">','</a>'));
+))->setHelp(sprintf('If this option is set, then DHCP static mappings will be registered in the DNS Resolver, so that their name can be resolved. '.
+					'The domain in %sSystem: General setup%s should also be set to the proper value.','<a href="system.php">','</a>'));
 
 $btnadv = new Form_Button(
 	'btnadvcustom',
diff --git a/src/usr/local/www/services_unbound_acls.php b/src/usr/local/www/services_unbound_acls.php
index 23fae6d756..db5b2e25c0 100644
--- a/src/usr/local/www/services_unbound_acls.php
+++ b/src/usr/local/www/services_unbound_acls.php
@@ -148,21 +148,21 @@ if ($_POST) {
 				$networkacl[$x]['mask'] = $pconfig["mask{$x}"];
 				$networkacl[$x]['description'] = $pconfig["description{$x}"];
 				if (!is_ipaddr($networkacl[$x]['acl_network'])) {
-					$input_errors[] = gettext("You must enter a valid IP address for each row under Networks.");
+					$input_errors[] = gettext("A valid IP address must be entered for each row under Networks.");
 				}
 
 				if (is_ipaddr($networkacl[$x]['acl_network'])) {
 					if (!is_subnet($networkacl[$x]['acl_network']."/".$networkacl[$x]['mask'])) {
-						$input_errors[] = gettext("You must enter a valid IPv4 netmask for each IPv4 row under Networks.");
+						$input_errors[] = gettext("A valid IPv4 netmask must be entered for each IPv4 row under Networks.");
 					}
 				} else if (function_exists("is_ipaddrv6")) {
 					if (!is_ipaddrv6($networkacl[$x]['acl_network'])) {
-						$input_errors[] = gettext("You must enter a valid IPv6 address for {$networkacl[$x]['acl_network']}.");
+						$input_errors[] = gettext("A valid IPv6 address must be entered for {$networkacl[$x]['acl_network']}.");
 					} else if (!is_subnetv6($networkacl[$x]['acl_network']."/".$networkacl[$x]['mask'])) {
-						$input_errors[] = gettext("You must enter a valid IPv6 netmask for each IPv6 row under Networks.");
+						$input_errors[] = gettext("A valid IPv6 netmask must be entered for each IPv6 row under Networks.");
 					}
 				} else {
-					$input_errors[] = gettext("You must enter a valid IP address for each row under Networks.");
+					$input_errors[] = gettext("A valid IP address must be entered for each row under Networks.");
 				}
 			} else if (isset($networkacl[$x])) {
 				unset($networkacl[$x]);
@@ -203,7 +203,7 @@ $actionHelp =
 					sprintf(gettext('%sDeny:%s Stops queries from hosts within the netblock defined below.%s'), '<span class="text-success"><strong>', '</strong></span>', '<br />') .
 					sprintf(gettext('%sRefuse:%s Stops queries from hosts within the netblock defined below, but sends a DNS rcode REFUSED error message back to the client.%s'), '<span class="text-success"><strong>', '</strong></span>', '<br />') .
 					sprintf(gettext('%sAllow:%s Allow queries from hosts within the netblock defined below.%s'), '<span class="text-success"><strong>', '</strong></span>', '<br />') .
-					sprintf(gettext('%sAllow Snoop:%s Allow recursive and nonrecursive access from hosts within the netblock defined below. Used for cache snooping and ideally should only be configured for your administrative host.'), '<span class="text-success"><strong>', '</strong></span>'); 
+					sprintf(gettext('%sAllow Snoop:%s Allow recursive and nonrecursive access from hosts within the netblock defined below. Used for cache snooping and ideally should only be configured for the administrative host.'), '<span class="text-success"><strong>', '</strong></span>'); 
 
 $pgtitle = array(gettext("Services"), gettext("DNS Resolver"), gettext("Access Lists"));
 
@@ -222,7 +222,7 @@ if ($savemsg) {
 }
 
 if (is_subsystem_dirty('unbound')) {
-	print_apply_box(gettext("The DNS resolver configuration has been changed.") . "<br />" . gettext("You must apply the changes in order for them to take effect."));
+	print_apply_box(gettext("The DNS resolver configuration has been changed.") . "<br />" . gettext("The changes must be applied for them to take effect."));
 }
 
 $tab_array = array();
@@ -270,7 +270,7 @@ if ($act == "new" || $act == "edit") {
 		'Description',
 		'text',
 		$pconfig['description']
-	))->setHelp('You may enter a description here for your reference.');
+	))->setHelp('A description may be entered here for administrative reference.');
 
 	$numrows = count($networkacl) - 1;
 	$counter = 0;
diff --git a/src/usr/local/www/services_unbound_advanced.php b/src/usr/local/www/services_unbound_advanced.php
index 22b9b86a9d..c10c478b29 100644
--- a/src/usr/local/www/services_unbound_advanced.php
+++ b/src/usr/local/www/services_unbound_advanced.php
@@ -231,7 +231,7 @@ if ($savemsg) {
 }
 
 if (is_subsystem_dirty('unbound')) {
-	print_apply_box(gettext("The DNS resolver configuration has been changed.") . "<br />" . gettext("You must apply the changes in order for them to take effect."));
+	print_apply_box(gettext("The DNS resolver configuration has been changed.") . "<br />" . gettext("The changes must be applied for them to take effect."));
 }
 
 $tab_array = array();
@@ -306,7 +306,7 @@ $section->addInput(new Form_Select(
 	$pconfig['edns_buffer_size'],
 	array_combine(array("512", "1480", "4096"), array("512", "1480", "4096"))
 ))->setHelp('Number of bytes size to advertise as the EDNS reassembly buffer size. This is the value that is used in UDP datagrams sent to peers. ' .
-			'RFC recommendation is 4096 (which is the default). If you have fragmentation reassemble problems, usually seen as timeouts, then a value of 1480 should help. ' .
+			'RFC recommendation is 4096 (which is the default). If fragmentation reassemble problems occur, usually seen as timeouts, then a value of 1480 should help. ' .
 			'The 512 value bypasses most MTU path problems, but it can generate an excessive amount of TCP fallback.');
 
 $section->addInput(new Form_Select(
diff --git a/src/usr/local/www/services_unbound_domainoverride_edit.php b/src/usr/local/www/services_unbound_domainoverride_edit.php
index 776b32e15c..360f3191c2 100644
--- a/src/usr/local/www/services_unbound_domainoverride_edit.php
+++ b/src/usr/local/www/services_unbound_domainoverride_edit.php
@@ -169,7 +169,7 @@ $section->addInput(new Form_Input(
 	'Description',
 	'text',
 	$pconfig['descr']
-))->setHelp('You may enter a description here for your reference (not parsed).');
+))->setHelp('A description may be entered here for administrative reference (not parsed).');
 
 if (isset($id) && $a_domainOverrides[$id]) {
 	$section->addInput(new Form_Input(
diff --git a/src/usr/local/www/services_unbound_host_edit.php b/src/usr/local/www/services_unbound_host_edit.php
index 3ae8c7f3b3..fadc451360 100644
--- a/src/usr/local/www/services_unbound_host_edit.php
+++ b/src/usr/local/www/services_unbound_host_edit.php
@@ -270,7 +270,7 @@ $section->addInput(new Form_Input(
 	'Description',
 	'text',
 	$pconfig['descr']
-))->setHelp('You may enter a description here for your reference (not parsed).');
+))->setHelp('A description may be entered here for administrative reference (not parsed).');
 
 if (isset($id) && $a_hosts[$id]) {
 	$section->addInput(new Form_Input(