commit fb572e810abe247c273c27ffafb129430b13be1f
Author: Phil Davis <phil.davis@inf.org>
Date:   Tue Jan 24 11:36:04 2017 +0545

    More required fields for Interface pages

diff --git a/src/usr/local/www/interfaces.php b/src/usr/local/www/interfaces.php
index fd17f81de0..10def774be 100755
--- a/src/usr/local/www/interfaces.php
+++ b/src/usr/local/www/interfaces.php
@@ -3598,10 +3598,14 @@ events.push(function() {
 		$('#adv_dhcp_pt_initial_interval').val(initialinterval);
 	}
 
-	function setDialOnDemandItems() {
+	function setPPPoEDialOnDemandItems() {
 		setRequired('pppoe_idletimeout', $('#pppoe_dialondemand').prop('checked'));
 	}
 
+	function setPPTPDialOnDemandItems() {
+		setRequired('pptp_idletimeout', $('#pptp_dialondemand').prop('checked'));
+	}
+
 	// ---------- On initial page load ------------------------------------------------------------
 
 	updateType($('#type').val());
@@ -3611,7 +3615,8 @@ events.push(function() {
 	hideClass('dhcpadvanced', true);
 	show_dhcp6adv();
 	setDHCPoptions();
-	setDialOnDemandItems();
+	setPPPoEDialOnDemandItems();
+	setPPTPDialOnDemandItems();
 
 	// Set preset buttons on page load
 	var sv = "<?=htmlspecialchars($pconfig['adv_dhcp_pt_values']);?>";
@@ -3684,7 +3689,11 @@ events.push(function() {
 
 	// On click . .
 	$('#pppoe_dialondemand').click(function () {
-		setDialOnDemandItems();
+		setPPPoEDialOnDemandItems();
+	});
+
+	$('#pptp_dialondemand').click(function () {
+		setPPTPDialOnDemandItems();
 	});
 
 	$('[name=adv_dhcp_pt_values]').click(function () {
diff --git a/src/usr/local/www/interfaces_gif_edit.php b/src/usr/local/www/interfaces_gif_edit.php
index 0f5c9d4906..630a0581b0 100644
--- a/src/usr/local/www/interfaces_gif_edit.php
+++ b/src/usr/local/www/interfaces_gif_edit.php
@@ -177,7 +177,7 @@ $section = new Form_Section('GIF Configuration');
 
 $section->addInput(new Form_Select(
 	'if',
-	'Parent Interface',
+	'*Parent Interface',
 	$pconfig['if'],
 	build_parent_list()
 ))->setHelp('This interface serves as the local address to be used for the GIF tunnel.');
@@ -202,7 +202,7 @@ $section->addInput(new Form_IpAddress(
 
 $section->addInput(new Form_Select(
 	'tunnel-remote-net',
-	'GIF tunnel subnet',
+	'*GIF tunnel subnet',
 	$pconfig['tunnel-remote-net'],
 	array_combine(range(128, 1, -1), range(128, 1, -1))
 ))->setHelp('The subnet is used for determining the network that is tunnelled.');
diff --git a/src/usr/local/www/interfaces_gre_edit.php b/src/usr/local/www/interfaces_gre_edit.php
index 8fa327ab26..5899927126 100644
--- a/src/usr/local/www/interfaces_gre_edit.php
+++ b/src/usr/local/www/interfaces_gre_edit.php
@@ -171,7 +171,7 @@ $section = new Form_Section('GRE Configuration');
 
 $section->addInput(new Form_Select(
 	'if',
-	'Parent Interface',
+	'*Parent Interface',
 	$pconfig['if'],
 	build_parent_list()
 ))->setHelp('This interface serves as the local address to be used for the GRE tunnel.');
@@ -196,7 +196,7 @@ $section->addInput(new Form_IpAddress(
 
 $section->addInput(new Form_Select(
 	'tunnel-remote-net',
-	'GRE tunnel subnet',
+	'*GRE tunnel subnet',
 	$pconfig['tunnel-remote-net'],
 	array_combine(range(128, 1, -1), range(128, 1, -1))
 ))->setHelp('The subnet is used for determining the network that is tunnelled.');
diff --git a/src/usr/local/www/interfaces_lagg_edit.php b/src/usr/local/www/interfaces_lagg_edit.php
index 6bacca3164..ad24d53fe4 100644
--- a/src/usr/local/www/interfaces_lagg_edit.php
+++ b/src/usr/local/www/interfaces_lagg_edit.php
@@ -245,7 +245,7 @@ $section->addInput(new Form_Select(
 
 $section->addInput(new Form_Select(
 	'proto',
-	'LAGG Protocol',
+	'*LAGG Protocol',
 	$pconfig['proto'],
 	array_combine($laggprotos, $laggprotosuc)
 ))->setHelp($protohelp);
diff --git a/src/usr/local/www/interfaces_qinq_edit.php b/src/usr/local/www/interfaces_qinq_edit.php
index 7d62fd14c9..93ea87db2c 100644
--- a/src/usr/local/www/interfaces_qinq_edit.php
+++ b/src/usr/local/www/interfaces_qinq_edit.php
@@ -229,7 +229,7 @@ $section = new Form_Section('QinQ Configuration');
 
 $section->addInput(new Form_Select(
 	'if',
-	'Parent interface',
+	'*Parent interface',
 	$pconfig['if'],
 	build_parent_list()
 ))->setHelp('Only QinQ capable interfaces will be shown.');
diff --git a/src/usr/local/www/interfaces_vlan_edit.php b/src/usr/local/www/interfaces_vlan_edit.php
index c001550527..067de87d4e 100644
--- a/src/usr/local/www/interfaces_vlan_edit.php
+++ b/src/usr/local/www/interfaces_vlan_edit.php
@@ -183,7 +183,7 @@ $section = new Form_Section('VLAN Configuration');
 
 $section->addInput(new Form_Select(
 	'if',
-	'Parent Interface',
+	'*Parent Interface',
 	$pconfig['if'],
 	build_interfaces_list()
 ))->setWidth(6)->setHelp('Only VLAN capable interfaces will be shown.');
diff --git a/src/usr/local/www/interfaces_wireless_edit.php b/src/usr/local/www/interfaces_wireless_edit.php
index f0d6458095..a37e8174b6 100644
--- a/src/usr/local/www/interfaces_wireless_edit.php
+++ b/src/usr/local/www/interfaces_wireless_edit.php
@@ -176,14 +176,14 @@ $section = new Form_Section('Wireless Interface Configuration');
 
 $section->addInput(new Form_Select(
 	'if',
-	'Parent Interface',
+	'*Parent Interface',
 	$pconfig['if'],
 	build_parent_list()
 ));
 
 $section->addInput(new Form_Select(
 	'mode',
-	'Mode',
+	'*Mode',
 	$pconfig['mode'],
 	array(
 		'bss' => gettext('Infrastructure (BSS)'),