commit 2f647f7ce3806f256de8a8bb732f88b8351d73f1
Author: Scott Ullrich <sullrich@pfsense.org>
Date:   Sun Mar 15 22:40:37 2009 -0400

    Use divisibles of 512

diff --git a/etc/rc b/etc/rc
index d064d2f567..8fd2fd6623 100755
--- a/etc/rc
+++ b/etc/rc
@@ -217,16 +217,16 @@ if [ "$DISABLESYSLOGCLOG" -gt "0" ]; then
 	touch /var/log/ntpd.log
 else 
 	# generate circular logfiles
-	fifolog_create  -s 512144 /var/log/system.log
-	fifolog_create -s 512144 /var/log/filter.log
-	fifolog_create -s 65535 /var/log/dhcpd.log
-	fifolog_create -s 65535 /var/log/vpn.log
-	fifolog_create -s 65535 /var/log/openvpn.log
-	fifolog_create -s 65535 /var/log/portalauth.log
-	fifolog_create -s 65535 /var/log/ipsec.log
-	fifolog_create -s 65535 /var/log/relayd.log
-	fifolog_create -s 65535 /var/log/lighttpd.log
-	fifolog_create -s 65535 /var/log/ntpd.log
+	fifolog_create -s 511488 /var/log/system.log
+	fifolog_create -s 511488 /var/log/filter.log
+	fifolog_create -s 50688 /var/log/dhcpd.log
+	fifolog_create -s 50688 /var/log/vpn.log
+	fifolog_create -s 50688 /var/log/openvpn.log
+	fifolog_create -s 50688 /var/log/portalauth.log
+	fifolog_create -s 50688 /var/log/ipsec.log
+	fifolog_create -s 50688 /var/log/relayd.log
+	fifolog_create -s 50688 /var/log/lighttpd.log
+	fifolog_create -s 50688 /var/log/ntpd.log
 fi 
 # change permissions on newly created fifolog files.
 chmod 0600 /var/log/system.log /var/log/filter.log /var/log/dhcpd.log /var/log/vpn.log /var/log/portalauth.log /var/log/relayd.log	
diff --git a/usr/local/www/diag_logs.php b/usr/local/www/diag_logs.php
index b97a3b04a2..5c1809aa92 100755
--- a/usr/local/www/diag_logs.php
+++ b/usr/local/www/diag_logs.php
@@ -55,7 +55,7 @@ if ($_POST['clear']) {
 		system_syslogd_start();
 	} else {  
 		exec("killall syslogd");
-		exec("/usr/sbin/fifolog_create -s 262144 {$system_logfile}");
+		exec("/usr/sbin/fifolog_create -s 511488 {$system_logfile}");
 		system_syslogd_start();
 	}
 
diff --git a/usr/local/www/diag_logs_auth.php b/usr/local/www/diag_logs_auth.php
index 3db4eeb88c..775419ae53 100755
--- a/usr/local/www/diag_logs_auth.php
+++ b/usr/local/www/diag_logs_auth.php
@@ -50,7 +50,7 @@ if ($_POST['clear']) {
 		unlink($portal_logfile);
 		touch($portal_logfile);
 	} else {
-		exec("/usr/sbin/fifolog_create -s 262144 {$portal_logfile}");
+		exec("/usr/sbin/fifolog_create -s 511488 {$portal_logfile}");
 	}
 }
 
diff --git a/usr/local/www/diag_logs_dhcp.php b/usr/local/www/diag_logs_dhcp.php
index 3573183182..4a232f807a 100755
--- a/usr/local/www/diag_logs_dhcp.php
+++ b/usr/local/www/diag_logs_dhcp.php
@@ -52,7 +52,7 @@ if ($_POST['clear']) {
 		unlink($dhcpd_logfile);
 		touch($dhcpd_logfile);
 	} else {
-		exec("/usr/sbin/fifolog_create -s 262144 {$dhcpd_logfile}");
+		exec("/usr/sbin/fifolog_create -s 511488 {$dhcpd_logfile}");
 	}
 }
 
diff --git a/usr/local/www/diag_logs_filter.php b/usr/local/www/diag_logs_filter.php
index daa9598675..a7fafd2774 100755
--- a/usr/local/www/diag_logs_filter.php
+++ b/usr/local/www/diag_logs_filter.php
@@ -61,7 +61,7 @@ if ($_POST['clear']) {
 		touch("/var/log/filter.log");
 	} else {	
 		exec("killall syslogd");
-		exec("/usr/sbin/fifolog_create -s 512144 /var/log/filter.log");
+		exec("/usr/sbin/fifolog_create -s 511488 /var/log/filter.log");
 		system_syslogd_start();
 	}
 }
diff --git a/usr/local/www/diag_logs_filter_dynamic.php b/usr/local/www/diag_logs_filter_dynamic.php
index ffc91d9799..5b161d43c4 100755
--- a/usr/local/www/diag_logs_filter_dynamic.php
+++ b/usr/local/www/diag_logs_filter_dynamic.php
@@ -54,7 +54,7 @@ if ($_POST['clear']) {
 		touch("/var/log/filter.log");
 	} else {
 		exec("killall syslogd");
-		exec("/usr/sbin/fifolog_create -s 262144 /var/log/filter.log");
+		exec("/usr/sbin/fifolog_create -s 511488 /var/log/filter.log");
 		system_syslogd_start();
 	}
 }
diff --git a/usr/local/www/diag_logs_ipsec.php b/usr/local/www/diag_logs_ipsec.php
index 58a4372226..dbc00e030a 100755
--- a/usr/local/www/diag_logs_ipsec.php
+++ b/usr/local/www/diag_logs_ipsec.php
@@ -69,7 +69,7 @@ if ($_POST['clear']) {
 		touch($ipsec_logfile);
 	} else {
 		exec("killall syslogd");
-		exec("/usr/sbin/fifolog_create -s 262144 {$ipsec_logfile}");
+		exec("/usr/sbin/fifolog_create -s 511488 {$ipsec_logfile}");
 		system_syslogd_start();
 	}
 }
diff --git a/usr/local/www/diag_logs_ntpd.php b/usr/local/www/diag_logs_ntpd.php
index 10d751770f..39cf400fbc 100644
--- a/usr/local/www/diag_logs_ntpd.php
+++ b/usr/local/www/diag_logs_ntpd.php
@@ -51,7 +51,7 @@ if ($_POST['clear']) {
 		touch($ntpd_logfile);
 	} else {
 		exec("killall syslogd");
-		exec("/usr/sbin/fifolog_create -s 262144 {$ntpd_logfile}");
+		exec("/usr/sbin/fifolog_create -s 511488 {$ntpd_logfile}");
 		system_syslogd_start();
 	}
 }
diff --git a/usr/local/www/diag_logs_relayd.php b/usr/local/www/diag_logs_relayd.php
index f2b0c50ba5..4c0de94d96 100755
--- a/usr/local/www/diag_logs_relayd.php
+++ b/usr/local/www/diag_logs_relayd.php
@@ -52,7 +52,7 @@ if ($_POST['clear']) {
 		touch($relayd_logfile);
 	} else {
 		exec("killall syslogd");
-		exec("/usr/sbin/fifolog_create -s 262144 {$relayd_logfile}");
+		exec("/usr/sbin/fifolog_create -s 511488 {$relayd_logfile}");
 		system_syslogd_start();
 	}
 }
diff --git a/usr/local/www/diag_logs_slbd.php b/usr/local/www/diag_logs_slbd.php
index 7e6feba470..5ba55f635e 100755
--- a/usr/local/www/diag_logs_slbd.php
+++ b/usr/local/www/diag_logs_slbd.php
@@ -52,7 +52,7 @@ if ($_POST['clear']) {
 		touch($slbd_logfile);
 	} else {
 		exec("killall syslogd");
-		exec("/usr/sbin/fifolog_create -s 262144 {$slbd_logfile}");
+		exec("/usr/sbin/fifolog_create -s 511488 {$slbd_logfile}");
 		system_syslogd_start();
 	}
 }
diff --git a/usr/local/www/diag_logs_vpn.php b/usr/local/www/diag_logs_vpn.php
index fa545d3616..5ece0146a3 100755
--- a/usr/local/www/diag_logs_vpn.php
+++ b/usr/local/www/diag_logs_vpn.php
@@ -49,7 +49,7 @@ if ($_POST['clear']) {
 		unlink("/var/log/vpn.log");
 		touch("/var/log/vpn.log");
 	} else {	
-		exec("/usr/sbin/fifolog_create -s 65536 /var/log/vpn.log");
+		exec("/usr/sbin/fifolog_create -s 50688 /var/log/vpn.log");
 	}
 	/* redirect to avoid reposting form data on refresh */
 	header("Location: diag_logs_vpn.php");
diff --git a/usr/local/www/diag_pkglogs.php b/usr/local/www/diag_pkglogs.php
index 91091ca8a7..9c772392c6 100755
--- a/usr/local/www/diag_pkglogs.php
+++ b/usr/local/www/diag_pkglogs.php
@@ -51,7 +51,7 @@ require("guiconfig.inc");
 if(!($nentries = $config['syslog']['nentries'])) $nentries = 50;
 
 if ($_POST['clear']) {
-	exec("/usr/sbin/fifolog_create -s 262144 {$logfile}");
+	exec("/usr/sbin/fifolog_create -s 511488 {$logfile}");
 }
 $i = 0;
 $pkgwithlogging = false;